unit Unit1ch;

interface

uses
  Windows, SysUtils, Classes, Forms, Dialogs, 
   Audio_u, mmsystem, StdCtrls, NMUDP, ExtCtrls, Menus,
  StTrIcon, ImgList, Controls, StBase, StShBase;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Voice: TAudio;
    StartV: TButton;
    StopV: TButton;
    Vnetio: TNMUDP;
    Label1: TLabel;
    Portadr: TEdit;
    Label3: TLabel;
    Hostn: TEdit;
    txtUDP: TNMUDP;
    sendtxt: TEdit;
    Sendtext: TButton;
    Label2: TLabel;
    Nick: TEdit;
    MkMes: TButton;
    RestOnMsg: TCheckBox;
    EnSelect: TCheckBox;
    Talk: TButton;
    Aboutb: TPanel;
    TrayIcon: TStTrayIcon;
    TrayMenu: TPopupMenu;
    Images: TImageList;
    SendFile: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure StartVClick(Sender: TObject);
    procedure StopVClick(Sender: TObject);
    procedure VoiceRecord(Sender: TObject; LP, RP: Pointer;
      BufferSize: Word);
    procedure VnetioDataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure ChanNetParam;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SendtextClick(Sender: TObject);
    procedure txtUDPDataReceived(Sender: TComponent; NumberBytes: Integer;
      FromIP: String; Port: Integer);
    procedure sendtxtKeyPress(Sender: TObject; var Key: Char);
    procedure NickExit(Sender: TObject);
    procedure PortadrExit(Sender: TObject);
    procedure HostnExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MkMesClick(Sender: TObject);
    procedure EnSelectClick(Sender: TObject);
    procedure TalkMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TalkMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AboutbClick(Sender: TObject);
    procedure TrayIconRestore(Sender: TObject);
    procedure TrayIconMinimize(Sender: TObject);
    procedure SendFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  MaxStr=255;
  cmdsign='/';
var
  Form1: TForm1;
  StartedP,StartedR,Vtrans,Vres: Boolean;  //  
  Trayed,ReciveF:Boolean;
  NumMsg:integer;
  sendfilename,resfilename:string;
  
implementation

uses Unit2ch;

{$R *.DFM}

procedure TForm1.ChanNetParam;
var err:boolean;
begin
  err:=false;
  try
  txtUDP.LocalPort:=strtoint(Portadr.Text)+2;
  except
    on EConvertError do
     begin
     ShowMessage('   ');
     Portadr.Text:=inttostr(6000);
     err:=True;
     end;
  end;
  if err then
    begin
      ChanNetParam;
      exit;
    end;
  txtUDP.RemotePort:=txtUDP.LocalPort;
  txtUDP.RemoteHost:=Hostn.Text;
  Vnetio.LocalPort:=strtoint(Portadr.Text);
  Vnetio.RemotePort:=Vnetio.LocalPort;
  Vnetio.RemoteHost:=Hostn.Text;
end;

procedure InvHost;
begin
  ShowMessage('  ');
  Form1.Hostn.Text:='127.0.0.1';
  Form1.ChanNetParam;
end;

procedure SenFile(fname:string);
var
 TST:Tmemorystream;
begin
  TST:=Tmemorystream.Create;
  TST.LoadFromFile(fname);
  try
    Form1.Vnetio.SendStream(TST);
  except
    InvHost;
  end;
  TST.Free;
end;
procedure ReciveFile(fname:string);
var
 RST:Tmemorystream;
begin
  RST:=Tmemorystream.Create;
  Form1.Vnetio.ReadStream(RST);
  RST.SaveToFile(fname);
  RST.Free;
end;

//   " "
procedure Startplay;
begin
  StartedP:=True;
end;
procedure Stopplay;
begin
if StartedP then
  begin
  if Vres then Form1.Voice.Player.Stop;
  StartedP:=False;
  end;
end;
procedure StartRec;
begin
  if (not StartedR) then
    if not(Form1.Voice.Recorder.Start) then Form1.Memo1.Lines.Add(Form1.Voice.ErrorMessage)
    else
      begin
        StartedR:=True;
      end;
end;
procedure StopRec;
begin
  if not(Form1.Voice.Recorder.Stop) then Form1.Memo1.Lines.Add(Form1.Voice.ErrorMessage);
  StartedR:=False;
end;

//    
procedure TForm1.VoiceRecord(Sender: TObject; LP, RP: Pointer;
  BufferSize: Word);
procedure Transbuf(adr:Pointer;Bufsize:Word);
var
 TST:Tmemorystream;
begin
if (not Vtrans) then
  begin
    Vtrans:=True;
    TST:=Tmemorystream.Create;
    TST.WriteBuffer(adr^,Bufsize);
    try
    Vnetio.SendStream(TST);
    except
      InvHost;
    end;
    TST.Free;
    Vtrans:=False;
  end;
end;
begin
  if StartedR then
  begin
//  Memo1.Lines.Add('Trans Snd');                     {!!!!!}
  Transbuf(LP,BufferSize);     //   UDP
  end;
end;

//     UDP
procedure TForm1.VnetioDataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String; Port: Integer);
var
 RST:Tmemorystream;
begin
//Memo1.Lines.Add('Resive Port '+inttostr(Port)+' Adr '+FromIP+' Len '+inttostr(NumberBytes));
if ReciveF then
  begin
  ReciveFile(resfilename);
  ReciveF:=False;
  end
else
if StartedP then
  if NumberBytes>0 then
  begin
  Vres:=True;      // 
  RST:=Tmemorystream.Create;
  Vnetio.ReadStream(RST);
  Voice.Player.Play(RST,nil,0); //  
  RST.Free;
  Vres:=False;   // 
  end;

end;
//   " "

procedure SendCmd(cmd:string);
var
  i:integer;
  chr:array[1..30] of char;
begin
  cmd:=cmdsign+cmd;
  for i:=1 to length(cmd) do
    chr[i]:=cmd[i];
  try
  Form1.txtUDP.SendBuffer(chr,length(cmd));
  except
    InvHost;
  end;
end;

procedure TForm1.StartVClick(Sender: TObject);
begin
  Vnetio.LocalPort:=strtoint(Portadr.Text);
  Vnetio.RemotePort:=Vnetio.LocalPort;
  Vnetio.RemoteHost:=Hostn.Text;
  Startplay;
  StartRec;
  if (StartedR and StartedP) then
    begin
      StartV.Visible:=False;
      StopV.Visible:=True;
      SendFile.Enabled:=False;
      Memo1.Lines.Add(' ');
    end;
end;

procedure TForm1.StopVClick(Sender: TObject);
begin
  Stopplay;
  StopRec;
  if ((not StartedR) and (not StartedP)) then
    begin
      StartV.Visible:=True;
      StopV.Visible:=False;
      SendFile.Enabled:=True;
      Memo1.Lines.Add(' ');
    end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Stopplay;
  StopRec;
end;

procedure TForm1.SendtextClick(Sender: TObject);
var
  txt:string;
  chr:array[1..MaxStr] of char;
  i:integer;
begin
  MkMes.Visible:=True;
  txt:=sendtxt.Text;
  if txt<>'' then
  begin
  txt:='['+Nick.Text+'] '+txt;
  sendtxt.Text:='';
  sendtxt.setfocus;
  for i:=1 to length(txt) do
    chr[i]:=txt[i];
  try
  txtUDP.SendBuffer(chr,length(txt));
  except
    InvHost;
  end;
  end;
end;

procedure TForm1.txtUDPDataReceived(Sender: TComponent;
  NumberBytes: Integer; FromIP: String; Port: Integer);
var
  txt:string;
  chr:array[1..MaxStr] of char;
  i:integer;
begin
//Memo1.Lines.Add('Resive Port '+inttostr(Port)+' From '+FromIP+' Len '+inttostr(NumberBytes));
  if NumberBytes>0 then
  begin
  txtUDP.ReadBuffer(chr,NumberBytes);
  txt:=chr;
  setlength(txt,NumberBytes);
  i:=pos(cmdsign,txt);
  if i>0 then
    begin
      txt:=copy(txt,length(cmdsign)+1,length(txt));
     // Memo1.Lines.Add('CMD!!! '+txt);
      if (not StartedR) then
      if txt='TALK' then
        begin
          Talk.Enabled:=False;
        end;
      if txt='ENDTALK' then
        begin
          Talk.Enabled:=True;
        end;
      if txt='SENDFILE' then
        begin
          if SaveDialog1.Execute then
            begin
              SendCmd('RES_OK');
              resfilename:=SaveDialog1.FileName;
              ReciveF:=True;
            end
          else
            SendCmd('RES_CANCEL');
        end;
      if txt='RES_OK' then
        begin
          SenFile(sendfilename);
          sendTxt.Enabled:=True;
          SendText.Enabled:=True;
          EnSelect.Enabled:=True;
          StartV.Enabled:=True;
          MkMes.Enabled:=True;
        end;
      if txt='RES_CANCEL' then
        begin
          sendTxt.Enabled:=True;
          SendText.Enabled:=True;
          EnSelect.Enabled:=True;
          StartV.Enabled:=True;
          MkMes.Enabled:=True;
        end;
      exit;
    end;
  i:=pos('] [msg] ',txt);
  if i>0 then     //Messge resived
    begin
       if Trayed then
         begin
           TrayIcon.ImageIndex:=0;
           inc(NumMsg);
           TrayIcon.Hint:='  - '+inttostr(NumMsg);
         end;
       PlaySound('Message.wav',HMODULE(nil),SND_ASYNC+SND_NODEFAULT);
       if RestOnMsg.Checked then
         {Application.Restore}TrayIcon.RestoreApplication;
    end;
  Memo1.Lines.Add(txt);
  end;
end;

procedure TForm1.sendtxtKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#13 then
    SendtextClick(self);
end;

procedure TForm1.NickExit(Sender: TObject);
begin
  sendtxt.MaxLength:=MaxStr-3-length(Nick.text);
end;

procedure TForm1.PortadrExit(Sender: TObject);
begin
  ChanNetParam;
end;

procedure TForm1.HostnExit(Sender: TObject);
var
  i:byte;
begin
  ChanNetParam;
  i:=pos('255',Hostn.Text);
  if i>0 then StartV.Enabled:=False
  else StartV.Enabled:=True;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ChanNetParam;
  if EnSelect.Checked then Talk.Enabled:=True
    else Talk.Enabled:=False;
  TrayIcon.Imageindex:=1;  
end;

procedure TForm1.MkMesClick(Sender: TObject);
var
  msg:string;
  chr:array[1..MaxStr] of char;
  i:integer;
begin
  OKBottomDlg.Memo1.MaxLength:=MaxStr-9-length(Nick.text);
  if OKBottomDlg.showmodal=mrOK then
  begin
    msg:=OKBottomDlg.Memo1.Text;
  OKBottomDlg.Memo1.MaxLength:=0;
  if msg<>'' then
  begin
  msg:='['+Nick.Text+'] [msg] '+msg;
  sendtxt.setfocus;
  for i:=1 to length(msg) do
    chr[i]:=msg[i];
  try
  txtUDP.SendBuffer(chr,length(msg));
  except
    InvHost;
  end;
  end;
  end;
end;

procedure TForm1.EnSelectClick(Sender: TObject);
begin
  if EnSelect.Checked then
    begin
      ChanNetParam;
      StopVClick(self);
      StartV.Enabled:=False;
      SendFile.Enabled:=False;
      Talk.Enabled:=True;
      Startplay;
    end
  else
  begin
    StopVClick(self);
    Talk.Enabled:=False;
    StartV.Enabled:=True;
    SendFile.Enabled:=True;
  end;
end;

procedure TForm1.TalkMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then
    begin
      Stopplay;
      SendCmd('TALK');
      StartRec;
    end;
end;

procedure TForm1.TalkMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then
    begin
      StopRec;
      SendCmd('ENDTALK');
      Startplay;
    end;
end;

procedure TForm1.AboutbClick(Sender: TObject);
begin
  ShowMessage('            Voice Chat'#13#10'  :  '#13#10'Copyright 2003, EREC ASNI');
end;

procedure TForm1.TrayIconRestore(Sender: TObject);
begin
  Trayed:=False;
  TrayIcon.Imageindex:=1;
  NumMsg:=0;
  TrayIcon.Hint:='  - '+inttostr(NumMsg);
end;

procedure TForm1.TrayIconMinimize(Sender: TObject);
begin
  Trayed:=True;
end;

procedure TForm1.SendFileClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    begin
      sendTxt.Enabled:=False;
      SendText.Enabled:=False;
      EnSelect.Enabled:=False;
      StartV.Enabled:=False;
      MkMes.Enabled:=False;
      sendfilename:=OpenDialog1.FileName;
      SendCmd('SENDFILE');

      {
      sendTxt.Enabled:=True;
      SendText.Enabled:=True;
      EnSelect.Enabled:=True;
      StartV.Enabled:=True;
      MkMes.Enabled:=True;
      }
    end;
end;

end.
